// --------------------------------------------------------------------
// Copyright (c) 2012 by Terasic Technologies Inc. 
// --------------------------------------------------------------------
//
// Permission:
//
//   Terasic grants permission to use and modify this code for use
//   in synthesis for all Terasic Development Boards and Altera Development 
//   Kits made by Terasic.  Other use of this code, including the selling 
//   ,duplication, or modification of any portion is strictly prohibited.
//
// Disclaimer:
//
//   This VHDL/Verilog or C/C++ source code is intended as a design reference
//   which illustrates how these types of functions can be implemented.
//   It is the user's responsibility to verify their design for
//   consistency and functionality through the use of formal
//   verification methods.  Terasic provides no warranty regarding the use 
//   or functionality of this code.
//
// --------------------------------------------------------------------
//           
//                     Terasic Technologies Inc
//                     E. Rd Sec. 1. JhuBei City,
//                     HsinChu County, Taiwan
//                     302
//
//                     web: http://www.terasic.com/   
//                     email: support@terasic.com
//
// --------------------------------------------------------------------
//Date:  Tue May  8 11:18:47 2012
//---------------------------------------------------------------------

//`define ENABLE_PCIE
//`define ENABLE_SATA_DEVICE
//`define ENABLE_SATA_HOST
//`define ENABLE_SATA_REFCLK
//`define ENABLE_SFPA
//`define ENABLE_SFPB
//`define ENABLE_SFPC
//`define ENABLE_SFPD
//`define ENABLE_SFP1G_REFCLK
//`define ENABLE_SFP_REFCLK
//`define ENABLE_HSMC_GXB


module TR5_f40w_golden_top(

							///////////BUTTON/////////////
							BUTTON,

							/////////CLK/////////
							CLK_CE,
							CLK_OD,
							CLK_OS,
							CLK_PR,
							CLK_RST_n,

							/////////CLOCK/////////
							CLOCK_SCL,
							CLOCK_SDA,

							/////////CPU/////////
							CPU_RESET_n,

							/////////FAN/////////
							FAN_CTRL,

							/////////FLASH/////////
							FLASH_ADV_n,
							FLASH_CE_n,
							FLASH_CLK,
							FLASH_OE_n,
							FLASH_RDY_BSY_n,
							FLASH_RESET_n,
							FLASH_WE_n,

							/////////FSM/////////
							FSM_A,
							FSM_D,

							/////////HSMC/////////
							HSMC_CLKIN0,
							HSMC_CLKIN_n1,
							HSMC_CLKIN_n2,
							HSMC_CLKIN_p1,
							HSMC_CLKIN_p2,
							HSMC_CLKOUT0,
							HSMC_CLKOUT_n1,
							HSMC_CLKOUT_n2,
							HSMC_CLKOUT_p1,
							HSMC_CLKOUT_p2,
							HSMC_D,
`ifdef ENABLE_HSMC_GXB
							HSMC_GXB_RX_p,
							HSMC_GXB_TX_p,
							HSMC_REFCLK_p,
`endif 
//							HSMC_RX_n,
							HSMC_RX_p,
							HSMC_SCL,
							HSMC_SDA,
//							HSMC_TX_n,
							HSMC_TX_p,

							/////////LED/////////
							LED,
							LED_BRACKET,
							LED_RJ45_L,
							LED_RJ45_R,

							/////////OSC/////////
							OSC_50_B3B,
							OSC_50_B3D,
							OSC_50_B4A,
							OSC_50_B4D,
							OSC_50_B7A,
							OSC_50_B7D,
							OSC_50_B8A,
							OSC_50_B8D,
`ifdef ENABLE_PCIE
							/////////PCIE/////////
							PCIE_PERST_n,
							PCIE_REFCLK_p,
							PCIE_RX_p,
							PCIE_SMBCLK,
							PCIE_SMBDAT,
							PCIE_TX_p,
							PCIE_WAKE_n,
`endif

							/////////RS422/////////
							RS422_DE,
							RS422_DIN,
							RS422_DOUT,
							RS422_RE_n,
							RS422_TE,

					
							/////////SATA/////////
`ifdef ENABLE_SATA_DEVICE							
							SATA_DEVICE_RX_p,
							SATA_DEVICE_TX_p,
`endif

`ifdef ENABLE_SATA_HOST
							SATA_HOST_RX_p,
							SATA_HOST_TX_p,
`endif

`ifdef ENABLE_SATA_REFCLK
							SATA_REFCLK_p,
`endif
							/////////SDI/////////
							

`ifdef ENABLE_SFP1G_REFCLK							
							/////////SFP1G/////////
							SFP1G_REFCLK_p,
`endif

`ifdef ENABLE_SFPA
							/////////SFPA/////////
							SFPA_LOS,
							SFPA_MOD0_PRSNT_n,
							SFPA_MOD1_SCL,
							SFPA_MOD2_SDA,
							SFPA_RATESEL,
							SFPA_RX_p,
							SFPA_TXDISABLE,
							SFPA_TXFAULT,
							SFPA_TX_p,
`endif

`ifdef ENABLE_SFPB
							/////////SFPB/////////
							SFPB_LOS,
							SFPB_MOD0_PRSNT_n,
							SFPB_MOD1_SCL,
							SFPB_MOD2_SDA,
							SFPB_RATESEL,
							SFPB_RX_p,
							SFPB_TXDISABLE,
							SFPB_TXFAULT,
							SFPB_TX_p,
`endif 

`ifdef ENABLE_SFPC
							/////////SFPC/////////
							SFPC_LOS,
							SFPC_MOD0_PRSNT_n,
							SFPC_MOD1_SCL,
							SFPC_MOD2_SDA,
							SFPC_RATESEL,
							SFPC_RX_p,
							SFPC_TXDISABLE,
							SFPC_TXFAULT,
							SFPC_TX_p,
`endif

`ifdef ENABLE_SFPD
							/////////SFPD/////////
							SFPD_LOS,
							SFPD_MOD0_PRSNT_n,
							SFPD_MOD1_SCL,
							SFPD_MOD2_SDA,
							SFPD_RATESEL,
							SFPD_RX_p,
							SFPD_TXDISABLE,
							SFPD_TXFAULT,
							SFPD_TX_p,
`endif

							/////////SFP/////////
`ifdef ENABLE_SFP_REFCLK
							SFP_REFCLK_p,
`endif
 
							/////////SMA/////////
							SMA_CLKIN,
							SMA_CLKOUT,

							/////////SSRAM/////////
							SSRAM_ADSC_n,
							SSRAM_ADSP_n,
							SSRAM_ADV_n,
							SSRAM_BE_n,
							SSRAM_CE1_n,
							SSRAM_CLK,
							SSRAM_DPA,
							SSRAM_GW_n,
							SSRAM_MODE,
							SSRAM_OE_n,
							SSRAM_WE_n,
							SSRAM_ZZ,

							/////////SWITCH/////////
							SW,

							////////SYSTEM_RESET_n//////
							SYSTEM_RESET_n,
							
							/////////TEMP/////////
							TEMP_CLK,
							TEMP_DATA,
							TEMP_INT_n,
							TEMP_OVERT_n,
);

//=======================================================
//  PORT declarations
//=======================================================

							///////////BUTTON/////////////

input								[3:0]							BUTTON;

///////// CLK /////////
output															CLK_CE;
output							[2:0]							CLK_OD;
output							[1:0]							CLK_OS;
output							[1:0]							CLK_PR;
output															CLK_RST_n;

///////// CLOCK /////////
output															CLOCK_SCL;
inout																CLOCK_SDA;

///////// CPU /////////
input																CPU_RESET_n;

///////// FAN /////////
inout																FAN_CTRL;

///////// FLASH /////////
output															FLASH_ADV_n;
output							[1:0]							FLASH_CE_n;
output															FLASH_CLK;
output															FLASH_OE_n;
input								[1:0]							FLASH_RDY_BSY_n;
output															FLASH_RESET_n;
output															FLASH_WE_n;

///////// FSM /////////
output							[26:0]						FSM_A;
inout								[31:0]						FSM_D;

///////// HSMC /////////
input																HSMC_CLKIN0;
input																HSMC_CLKIN_n1;
input																HSMC_CLKIN_n2;
input																HSMC_CLKIN_p1;
input																HSMC_CLKIN_p2;
output															HSMC_CLKOUT0;
output															HSMC_CLKOUT_n1;
output															HSMC_CLKOUT_n2;
output															HSMC_CLKOUT_p1;
output															HSMC_CLKOUT_p2;
inout								[3:0]							HSMC_D;
`ifdef ENABLE_HSMC_GXB
input								[7:0]							HSMC_GXB_RX_p;
output							[7:0]							HSMC_GXB_TX_p;
input																HSMC_REFCLK_p;
`endif 
//input								[16:0]						HSMC_RX_n;
input								[16:0]						HSMC_RX_p;
output															HSMC_SCL;
inout																HSMC_SDA;
//output							[16:0]						HSMC_TX_n;
output							[16:0]						HSMC_TX_p;

///////// LED /////////
output							[3:0]							LED;
output							[3:0]							LED_BRACKET;
output															LED_RJ45_L;
output															LED_RJ45_R;

///////// OSC /////////
input																OSC_50_B3B;
input																OSC_50_B3D;
input																OSC_50_B4A;
input																OSC_50_B4D;
input																OSC_50_B7A;
input																OSC_50_B7D;
input																OSC_50_B8A;
input																OSC_50_B8D;

`ifdef ENABLE_PCIE
///////// PCIE /////////
input																PCIE_PERST_n;
input																PCIE_REFCLK_p;
input								[7:0]							PCIE_RX_p;
inout																PCIE_SMBCLK;
inout																PCIE_SMBDAT;
output							[7:0]							PCIE_TX_p;
output															PCIE_WAKE_n;
`endif


///////// RS422 /////////
output															RS422_DE;
input																RS422_DIN;
output															RS422_DOUT;
output															RS422_RE_n;
output															RS422_TE;

///////// SATA /////////
`ifdef ENABLE_SATA_DEVICE
input																SATA_DEVICE_RX_p;
output															SATA_DEVICE_TX_p;
`endif

`ifdef ENABLE_SATA_HOST
input																SATA_HOST_RX_p;
output															SATA_HOST_TX_p;
`endif

`ifdef ENABLE_SATA_REFCLK
input																SATA_REFCLK_p;
`endif


`ifdef ENABLE_SFP1G_REFCLK
///////// SFP1G /////////
input																SFP1G_REFCLK_p;
`endif

`ifdef ENABLE_SFPA
///////// SFPA /////////
input																SFPA_LOS;
input																SFPA_MOD0_PRSNT_n;
output															SFPA_MOD1_SCL;
inout																SFPA_MOD2_SDA;
output							[1:0]							SFPA_RATESEL;
input																SFPA_RX_p;
output															SFPA_TXDISABLE;
input																SFPA_TXFAULT;
output															SFPA_TX_p;
`endif

`ifdef ENABLE_SFPB
///////// SFPB /////////
input																SFPB_LOS;
input																SFPB_MOD0_PRSNT_n;
output															SFPB_MOD1_SCL;
inout																SFPB_MOD2_SDA;
output							[1:0]							SFPB_RATESEL;
input																SFPB_RX_p;
output															SFPB_TXDISABLE;
input																SFPB_TXFAULT;
output															SFPB_TX_p;
`endif 

`ifdef ENABLE_SFPC
///////// SFPC /////////
input																SFPC_LOS;
input																SFPC_MOD0_PRSNT_n;
output															SFPC_MOD1_SCL;
inout																SFPC_MOD2_SDA;
output							[1:0]							SFPC_RATESEL;
input																SFPC_RX_p;
output															SFPC_TXDISABLE;
input																SFPC_TXFAULT;
output															SFPC_TX_p;
`endif

`ifdef ENABLE_SFPD
///////// SFPD /////////
input																SFPD_LOS;
input																SFPD_MOD0_PRSNT_n;
output															SFPD_MOD1_SCL;
inout																SFPD_MOD2_SDA;
output							[1:0]							SFPD_RATESEL;
input																SFPD_RX_p;
output															SFPD_TXDISABLE;
input																SFPD_TXFAULT;
output															SFPD_TX_p;
`endif

///////// SFP /////////
`ifdef ENABLE_SFP_REFCLK
input																SFP_REFCLK_p;
`endif


///////// SMA /////////
input																SMA_CLKIN;
output															SMA_CLKOUT;

///////// SSRAM /////////
output															SSRAM_ADSC_n;
output															SSRAM_ADSP_n;
output															SSRAM_ADV_n;
output							[3:0]							SSRAM_BE_n;
output															SSRAM_CE1_n;
output															SSRAM_CLK;
inout								[3:0]							SSRAM_DPA;
output															SSRAM_GW_n;
output															SSRAM_MODE;
output															SSRAM_OE_n;
output															SSRAM_WE_n;
output															SSRAM_ZZ;

///////// SWITCH /////////
input								[3:0]							SW;

//////// SYSTEM_RESET_n //////
input																SYSTEM_RESET_n;

///////// TEMP /////////
output															TEMP_CLK;
inout																TEMP_DATA;
input																TEMP_INT_n;
input																TEMP_OVERT_n;

//=======================================================
//  REG/WIRE declarations
//=======================================================


wire flash_dummy_addr;
wire reset_n;


//=======================================================
//  Structural coding
//=======================================================

assign reset_n = SYSTEM_RESET_n & CPU_RESET_n;

    S5_PFL u0 (
        .sys_clk_clk                                     (OSC_50_B3B),                                     //                    sys_clk.clk
        .cfi_flash_atb_bridge_0_out_tcm_address_out      ({FSM_A, flash_dummy_addr}),      // cfi_flash_atb_bridge_0_out.tcm_address_out
        .cfi_flash_atb_bridge_0_out_tcm_read_n_out       (FLASH_OE_n),       //                           .tcm_read_n_out
        .cfi_flash_atb_bridge_0_out_tcm_write_n_out      (FLASH_WE_n),      //                           .tcm_write_n_out
        .cfi_flash_atb_bridge_0_out_tcm_data_out         (FSM_D),         //                           .tcm_data_out
        .cfi_flash_atb_bridge_0_out_tcm_chipselect_n_out (FLASH_CE_n[0]), //                           .tcm_chipselect_n_out
        .merged_resets_in_reset_reset_n                  (reset_n),                  //     merged_resets_in_reset.reset_n
        .button_external_connection_export               (BUTTON),               // button_external_connection.export
        .led_external_connection_export                  (LED[3:1]),                  //    led_external_connection.export
        .led_rj45_external_connection_export             ({LED_RJ45_R, LED_RJ45_L}),             //    led_rj45_external_connection.export
        .led_bracket_external_connection_export          (LED_BRACKET),           // led_bracket_external_connection.export
        .temp_scl_external_connection_export             (TEMP_CLK),             // temp_scl_external_connection.export
        .temp_sda_external_connection_export             (TEMP_DATA)              // temp_sda_external_connection.export
		  
    );

	 
// Common Flash interface assignments
assign  FLASH_RESET_n = reset_n; // flash ready after FPGA is configured, reset during configuration
assign  FLASH_ADV_n   = 1'b0;
assign  FLASH_CLK    = 1'b0;
assign  FLASH_CE_n[1] = FLASH_CE_n[0]; // select both flash devices for double-wide 32 bit data width
//FLASH_RDY_BSY_n


// turn on fan
assign FAN_CTRL = 1'bz;

//
heart_beat heart_beat_clk50(
	.clk(OSC_50_B3B),
	.led(LED[0])
);
defparam heart_beat_clk50.DUR_BITS = 25;




endmodule
