
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module SI570_Demonstration(

	//////////// CLOCK //////////
	OSC_50_B3B,
	OSC_50_B3D,
	OSC_50_B4A,
	OSC_50_B4D,
	OSC_50_B7A,
	OSC_50_B7D,
	OSC_50_B8A,
	OSC_50_B8D,

	//////////// LED x 10 //////////
	LED,
	LED_BRACKET,
	LED_RJ45_L,
	LED_RJ45_R,

	//////////// BUTTON x 4 and CPU_RESET_n //////////
	BUTTON,
	CPU_RESET_n,

	//////////// SWITCH x 4 //////////
	SW,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// SFP+ A //////////
	SFPA_LOS,
	SFPA_MOD0_PRSNT_n,
	SFPA_MOD1_SCL,
	SFPA_MOD2_SDA,
	SFPA_RATESEL,
	SFPA_RX_p,
	SFPA_TX_p,
	SFPA_TXDISABLE,
	SFPA_TXFAULT, 
	
	//////////// SFP+ 10G Referece Clock (generated by the Programmalbe Oscillator Si570) //////////
	SFP_REFCLK_p,

	//////////// Programmalbe Oscillator SI570 //////////
	CLOCK_SCL,
	CLOCK_SDA 	
	
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		OSC_50_B3B;
input 		          		OSC_50_B3D;
input 		          		OSC_50_B4A;
input 		          		OSC_50_B4D;
input 		          		OSC_50_B7A;
input 		          		OSC_50_B7D;
input 		          		OSC_50_B8A;
input 		          		OSC_50_B8D;

//////////// LED x 10 //////////
output		     [3:0]		LED;
output		     [3:0]		LED_BRACKET;
output		          		LED_RJ45_L;
output		          		LED_RJ45_R;

//////////// BUTTON x 4 and CPU_RESET_n //////////
input 		     [3:0]		BUTTON;
input 		          		CPU_RESET_n;

//////////// SWITCH x 4 //////////
input 		     [3:0]		SW;

//////////// Fan //////////
inout 		          		FAN_CTRL;

//////////// SFP+ A //////////
input 		          		SFPA_LOS;
input 		          		SFPA_MOD0_PRSNT_n;
output		          		SFPA_MOD1_SCL;
inout 		          		SFPA_MOD2_SDA;
output		     [1:0]		SFPA_RATESEL;
input 		          		SFPA_RX_p;
output		          		SFPA_TX_p;
output		          		SFPA_TXDISABLE;
input 		          		SFPA_TXFAULT;

//////////// SFP+ 10G Referece Clock (generated by the Programmalbe Oscillator Si570) //////////
input 		          		SFP_REFCLK_p;

//////////// Programmalbe Oscillator SI570 //////////
output		          		CLOCK_SCL;
inout 		          		CLOCK_SDA;

//=======================================================
//  REG/WIRE declarations
//=======================================================

wire user_reset_n;
wire [2:0]	clk_type;
wire clock_freq_result;
wire si570_controller_start;
wire si570_config_ready;
wire reset_n;
wire clk_125;


//=======================================================
//  Structural coding
//=======================================================

assign user_reset_n = BUTTON[0];

//////////////////////////////////////////
// turn on the fan
assign FAN_CTRL = 1'b1;


////////////////////////////////////////
// configure external pll Si570 which provides xcvr ref clock

//assign clk_type = 3'b000;  //100.0 MHZ
//assign clk_type = 3'b001;  //125.0 MHZ
assign clk_type = 3'b010;  //156.25.0 MHZ
//assign clk_type = 3'b011;  //250 MHZ
//assign clk_type = 3'b100;  //312.5 MHZ
//assign clk_type = 3'b101;  //322.26 MHZ
//assign clk_type = 3'b110;  //644.53125 MHZ


si570_controller u1(

.iCLK(OSC_50_B3B), // system   clock 50mhz 
.iRST_n(user_reset_n), // system reset
.iStart(si570_controller_start), //giving 1 50Mhz cycle high pulse to set frequency
.iFREQ_MODE(SW[2:0]),//clock frequency mode   000:100Mhz, 001: 125Mhz, 010:156.25Mhz, 011:250Mhz, 100:312.5Mhz , 101:322.26Mhz , 110:644.53Mhz ,111:100Mhz 
.I2C_CLK(CLOCK_SCL),
.I2C_DATA(CLOCK_SDA),
.oController_Ready(),
);


edge_detector edge_detector(

.iCLK(OSC_50_B3B),
.iRST_n(user_reset_n),
.iIn(BUTTON[1]),
.oDEBOUNCE_OUT(si570_controller_start),
);


////////////////////////////////////////
// generate clk125 for phy_mgmt

mgmt_pll mgmt_pll_inst(
		.refclk(OSC_50_B3B),   //  refclk.clk
		.rst(1'b0),      //   reset.reset
		.outclk_0(clk_125), // outclk0.clk
		.locked(reset_n)    //  locked.export
	);
	
	
	
////////////////////////////////////////
// XCVR
wire phy_mgmt_clk_reset;
wire [31:0] tx_pattern;

assign phy_mgmt_clk_reset = ~reset_n | ~user_reset_n | SW[3];
assign tx_pattern = 32'h12345678;

LOW_LATENCY_XCVR_1x32 SFP_A(
		.phy_mgmt_clk(clk_125),         //       phy_mgmt_clk.clk
		.phy_mgmt_clk_reset(phy_mgmt_clk_reset),   // phy_mgmt_clk_reset.reset
		.phy_mgmt_address(),     //           phy_mgmt.address
		.phy_mgmt_read(),        //                   .read
		.phy_mgmt_readdata(),    //                   .readdata
		.phy_mgmt_waitrequest(), //                   .waitrequest
		.phy_mgmt_write(),       //                   .write
		.phy_mgmt_writedata(),   //                   .writedata
		.tx_ready(),             //           tx_ready.export
		.rx_ready(),             //           rx_ready.export
		.pll_ref_clk(SFP_REFCLK_p),          //        pll_ref_clk.clk
		.pll_locked(),           //         pll_locked.export
		.tx_serial_data(SFPA_TX_p),       //     tx_serial_data.export
		.rx_serial_data(SFPA_RX_p),       //     rx_serial_data.export
		.rx_is_lockedtoref(),    //  rx_is_lockedtoref.export
		.rx_is_lockedtodata(),   // rx_is_lockedtodata.export
		.tx_clkout(),            //          tx_clkout.export
		.rx_clkout(),            //          rx_clkout.export
		.tx_parallel_data(tx_pattern),     //   tx_parallel_data.export
		.rx_parallel_data(),     //   rx_parallel_data.export
		.reconfig_from_xcvr(),   // reconfig_from_xcvr.reconfig_from_xcvr
		.reconfig_to_xcvr()      //   reconfig_to_xcvr.reconfig_to_xcvr
	);
	

///////////////////////////////////////////
// generate heart beat for clock
wire xcvr_refclk_hb;
heart_beat heart_beat_xcvr_refclk(
	.clk(SFP_REFCLK_p),
	.led(xcvr_refclk_hb)
);

wire clk125_hb;
heart_beat heart_beat_clk_125(
	.clk(clk_125),
	.led(clk125_hb)
);


//////////////////////////////////////////
// led indication
assign LED[0] = phy_mgmt_clk_reset?1'b0:1'b1; // on if reset assert
assign LED[2] = clk125_hb; // heart beat of clk125
assign LED[3] = xcvr_refclk_hb; // heart beat of xcvr refclk


/////////////////////////////////////////////


endmodule
