-- LOW_LATENCY_XCVR_1x32.vhd

-- Generated using ACDS version 14.0 200 at 2014.07.17.10:30:16

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.numeric_std.all;

entity LOW_LATENCY_XCVR_1x32 is
	port (
		phy_mgmt_clk         : in  std_logic                      := '0';             --       phy_mgmt_clk.clk
		phy_mgmt_clk_reset   : in  std_logic                      := '0';             -- phy_mgmt_clk_reset.reset
		phy_mgmt_address     : in  std_logic_vector(8 downto 0)   := (others => '0'); --           phy_mgmt.address
		phy_mgmt_read        : in  std_logic                      := '0';             --                   .read
		phy_mgmt_readdata    : out std_logic_vector(31 downto 0);                     --                   .readdata
		phy_mgmt_waitrequest : out std_logic;                                         --                   .waitrequest
		phy_mgmt_write       : in  std_logic                      := '0';             --                   .write
		phy_mgmt_writedata   : in  std_logic_vector(31 downto 0)  := (others => '0'); --                   .writedata
		tx_ready             : out std_logic;                                         --           tx_ready.export
		rx_ready             : out std_logic;                                         --           rx_ready.export
		pll_ref_clk          : in  std_logic_vector(0 downto 0)   := (others => '0'); --        pll_ref_clk.clk
		pll_locked           : out std_logic_vector(0 downto 0);                      --         pll_locked.export
		tx_serial_data       : out std_logic_vector(0 downto 0);                      --     tx_serial_data.export
		rx_serial_data       : in  std_logic_vector(0 downto 0)   := (others => '0'); --     rx_serial_data.export
		rx_is_lockedtoref    : out std_logic_vector(0 downto 0);                      --  rx_is_lockedtoref.export
		rx_is_lockedtodata   : out std_logic_vector(0 downto 0);                      -- rx_is_lockedtodata.export
		tx_clkout            : out std_logic_vector(0 downto 0);                      --          tx_clkout.export
		rx_clkout            : out std_logic_vector(0 downto 0);                      --          rx_clkout.export
		tx_parallel_data     : in  std_logic_vector(31 downto 0)  := (others => '0'); --   tx_parallel_data.export
		rx_parallel_data     : out std_logic_vector(31 downto 0);                     --   rx_parallel_data.export
		reconfig_from_xcvr   : out std_logic_vector(91 downto 0);                     -- reconfig_from_xcvr.reconfig_from_xcvr
		reconfig_to_xcvr     : in  std_logic_vector(139 downto 0) := (others => '0')  --   reconfig_to_xcvr.reconfig_to_xcvr
	);
end entity LOW_LATENCY_XCVR_1x32;

architecture rtl of LOW_LATENCY_XCVR_1x32 is
	component altera_xcvr_low_latency_phy is
		generic (
			device_family               : string  := "";
			intended_device_variant     : string  := "ANY";
			data_path_type              : string  := "8G";
			operation_mode              : string  := "DUPLEX";
			lanes                       : integer := 1;
			bonded_mode                 : string  := "FALSE";
			serialization_factor        : integer := 0;
			pma_width                   : integer := 8;
			data_rate                   : string  := "1250 Mbps";
			base_data_rate              : string  := "1250 Mbps";
			pll_refclk_freq             : string  := "62.5 MHz";
			bonded_group_size           : integer := 1;
			select_10g_pcs              : integer := 0;
			tx_use_coreclk              : integer := 0;
			rx_use_coreclk              : integer := 0;
			tx_bitslip_enable           : integer := 0;
			tx_bitslip_width            : integer := 5;
			rx_bitslip_enable           : integer := 0;
			ppm_det_threshold           : string  := "100";
			phase_comp_fifo_mode        : string  := "NONE";
			loopback_mode               : string  := "NONE";
			gxb_analog_power            : string  := "AUTO";
			pll_lock_speed              : string  := "AUTO";
			tx_analog_power             : string  := "AUTO";
			tx_slew_rate                : string  := "OFF";
			tx_termination              : string  := "OCT_100_OHMS";
			tx_use_external_termination : string  := "false";
			tx_preemp_pretap            : integer := 0;
			tx_preemp_pretap_inv        : string  := "false";
			tx_preemp_tap_1             : integer := 0;
			tx_preemp_tap_2             : integer := 0;
			tx_preemp_tap_2_inv         : string  := "false";
			tx_vod_selection            : integer := 2;
			tx_common_mode              : string  := "0.65V";
			rx_pll_lock_speed           : string  := "AUTO";
			rx_common_mode              : string  := "0.82V";
			rx_termination              : string  := "OCT_100_OHMS";
			rx_use_external_termination : string  := "false";
			rx_eq_dc_gain               : integer := 1;
			rx_eq_ctrl                  : integer := 16;
			starting_channel_number     : integer := 0;
			pll_refclk_cnt              : integer := 1;
			en_synce_support            : integer := 0;
			plls                        : integer := 1;
			pll_refclk_select           : string  := "0";
			cdr_refclk_select           : integer := 0;
			pll_type                    : string  := "AUTO";
			pll_select                  : integer := 0;
			pll_reconfig                : integer := 0;
			channel_interface           : integer := 0;
			pll_feedback_path           : string  := "no_compensation";
			enable_fpll_clkdiv33        : integer := 1;
			mgmt_clk_in_mhz             : integer := 150;
			embedded_reset              : integer := 1
		);
		port (
			phy_mgmt_clk         : in  std_logic                      := 'X';             -- clk
			phy_mgmt_clk_reset   : in  std_logic                      := 'X';             -- reset
			phy_mgmt_address     : in  std_logic_vector(8 downto 0)   := (others => 'X'); -- address
			phy_mgmt_read        : in  std_logic                      := 'X';             -- read
			phy_mgmt_readdata    : out std_logic_vector(31 downto 0);                     -- readdata
			phy_mgmt_waitrequest : out std_logic;                                         -- waitrequest
			phy_mgmt_write       : in  std_logic                      := 'X';             -- write
			phy_mgmt_writedata   : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- writedata
			tx_ready             : out std_logic;                                         -- export
			rx_ready             : out std_logic;                                         -- export
			pll_ref_clk          : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- clk
			pll_locked           : out std_logic_vector(0 downto 0);                      -- export
			tx_serial_data       : out std_logic_vector(0 downto 0);                      -- export
			rx_serial_data       : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			rx_is_lockedtoref    : out std_logic_vector(0 downto 0);                      -- export
			rx_is_lockedtodata   : out std_logic_vector(0 downto 0);                      -- export
			tx_clkout            : out std_logic_vector(0 downto 0);                      -- export
			rx_clkout            : out std_logic_vector(0 downto 0);                      -- export
			tx_parallel_data     : in  std_logic_vector(31 downto 0)  := (others => 'X'); -- export
			rx_parallel_data     : out std_logic_vector(31 downto 0);                     -- export
			reconfig_from_xcvr   : out std_logic_vector(91 downto 0);                     -- reconfig_from_xcvr
			reconfig_to_xcvr     : in  std_logic_vector(139 downto 0) := (others => 'X'); -- reconfig_to_xcvr
			tx_bitslip           : in  std_logic_vector(6 downto 0)   := (others => 'X'); -- export
			rx_bitslip           : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			tx_coreclkin         : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			rx_coreclkin         : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			cdr_ref_clk          : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			pll_powerdown        : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			tx_digitalreset      : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			tx_analogreset       : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			tx_cal_busy          : out std_logic_vector(0 downto 0);                      -- export
			rx_digitalreset      : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			rx_analogreset       : in  std_logic_vector(0 downto 0)   := (others => 'X'); -- export
			rx_cal_busy          : out std_logic_vector(0 downto 0);                      -- export
			rx_cdr_reset_disable : in  std_logic_vector(0 downto 0)   := (others => 'X')  -- export
		);
	end component altera_xcvr_low_latency_phy;

begin

	low_latency_xcvr_1x32_inst : component altera_xcvr_low_latency_phy
		generic map (
			device_family               => "Stratix V",
			intended_device_variant     => "ANY",
			data_path_type              => "10G",
			operation_mode              => "DUPLEX",
			lanes                       => 1,
			bonded_mode                 => "xN",
			serialization_factor        => 32,
			pma_width                   => 32,
			data_rate                   => "10312.5 Mbps",
			base_data_rate              => "10312.5 Mbps",
			pll_refclk_freq             => "644.53125 MHz",
			bonded_group_size           => 1,
			select_10g_pcs              => 1,
			tx_use_coreclk              => 0,
			rx_use_coreclk              => 0,
			tx_bitslip_enable           => 0,
			tx_bitslip_width            => 7,
			rx_bitslip_enable           => 0,
			ppm_det_threshold           => "100",
			phase_comp_fifo_mode        => "NONE",
			loopback_mode               => "NONE",
			gxb_analog_power            => "AUTO",
			pll_lock_speed              => "AUTO",
			tx_analog_power             => "AUTO",
			tx_slew_rate                => "OFF",
			tx_termination              => "OCT_100_OHMS",
			tx_use_external_termination => "false",
			tx_preemp_pretap            => 0,
			tx_preemp_pretap_inv        => "false",
			tx_preemp_tap_1             => 0,
			tx_preemp_tap_2             => 0,
			tx_preemp_tap_2_inv         => "false",
			tx_vod_selection            => 2,
			tx_common_mode              => "0.65V",
			rx_pll_lock_speed           => "AUTO",
			rx_common_mode              => "0.82V",
			rx_termination              => "OCT_100_OHMS",
			rx_use_external_termination => "false",
			rx_eq_dc_gain               => 1,
			rx_eq_ctrl                  => 16,
			starting_channel_number     => 0,
			pll_refclk_cnt              => 1,
			en_synce_support            => 0,
			plls                        => 1,
			pll_refclk_select           => "0",
			cdr_refclk_select           => 0,
			pll_type                    => "CMU",
			pll_select                  => 0,
			pll_reconfig                => 0,
			channel_interface           => 0,
			pll_feedback_path           => "no_compensation",
			enable_fpll_clkdiv33        => 1,
			mgmt_clk_in_mhz             => 150,
			embedded_reset              => 1
		)
		port map (
			phy_mgmt_clk         => phy_mgmt_clk,         --       phy_mgmt_clk.clk
			phy_mgmt_clk_reset   => phy_mgmt_clk_reset,   -- phy_mgmt_clk_reset.reset
			phy_mgmt_address     => phy_mgmt_address,     --           phy_mgmt.address
			phy_mgmt_read        => phy_mgmt_read,        --                   .read
			phy_mgmt_readdata    => phy_mgmt_readdata,    --                   .readdata
			phy_mgmt_waitrequest => phy_mgmt_waitrequest, --                   .waitrequest
			phy_mgmt_write       => phy_mgmt_write,       --                   .write
			phy_mgmt_writedata   => phy_mgmt_writedata,   --                   .writedata
			tx_ready             => tx_ready,             --           tx_ready.export
			rx_ready             => rx_ready,             --           rx_ready.export
			pll_ref_clk          => pll_ref_clk,          --        pll_ref_clk.clk
			pll_locked           => pll_locked,           --         pll_locked.export
			tx_serial_data       => tx_serial_data,       --     tx_serial_data.export
			rx_serial_data       => rx_serial_data,       --     rx_serial_data.export
			rx_is_lockedtoref    => rx_is_lockedtoref,    --  rx_is_lockedtoref.export
			rx_is_lockedtodata   => rx_is_lockedtodata,   -- rx_is_lockedtodata.export
			tx_clkout            => tx_clkout,            --          tx_clkout.export
			rx_clkout            => rx_clkout,            --          rx_clkout.export
			tx_parallel_data     => tx_parallel_data,     --   tx_parallel_data.export
			rx_parallel_data     => rx_parallel_data,     --   rx_parallel_data.export
			reconfig_from_xcvr   => reconfig_from_xcvr,   -- reconfig_from_xcvr.reconfig_from_xcvr
			reconfig_to_xcvr     => reconfig_to_xcvr,     --   reconfig_to_xcvr.reconfig_to_xcvr
			tx_bitslip           => "0000000",            --        (terminated)
			rx_bitslip           => "0",                  --        (terminated)
			tx_coreclkin         => "0",                  --        (terminated)
			rx_coreclkin         => "0",                  --        (terminated)
			cdr_ref_clk          => "0",                  --        (terminated)
			pll_powerdown        => "0",                  --        (terminated)
			tx_digitalreset      => "0",                  --        (terminated)
			tx_analogreset       => "0",                  --        (terminated)
			tx_cal_busy          => open,                 --        (terminated)
			rx_digitalreset      => "0",                  --        (terminated)
			rx_analogreset       => "0",                  --        (terminated)
			rx_cal_busy          => open,                 --        (terminated)
			rx_cdr_reset_disable => "0"                   --        (terminated)
		);

end architecture rtl; -- of LOW_LATENCY_XCVR_1x32
